#include "stdafx.h"

#include <windowsx.h>
#include <commctrl.h>

#include "resource.h"
#include "Util.h"
#include "ProgressDlg.h"

////////////////////////////////////////////////////////////////////////
// i\EBhE
////////////////////////////////////////////////////////////////////////

// g̃CX^X
CProgressDlg* CProgressDlg::s_pThis;

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CProgressDlg::CProgressDlg(int stepMax, const char* caption) :
	m_step(0),
	m_stepMax(stepMax),
	m_hDlg(0),
	m_hWndParent(0),
	m_caption(caption),
	m_bCancel(false)
{
	// NOTE: !!!!!!!!!!
	//       CProgressDlg ̃CX^Xx 2 ȏg
	//       낵ƂɂȂB
	s_pThis = this;
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CProgressDlg::~CProgressDlg()
{
	Destory();
}

//----------------------------------------------------------------------
// EBhE\ 
//----------------------------------------------------------------------

bool CProgressDlg::DoModeless(HWND hWndParent)
{
	m_hWndParent = hWndParent;

	m_hDlg = CResourceManager::CreateDlg(MAKEINTRESOURCE(IDD_PROGRESS_DLG), hWndParent, DialogProcStatic);
	if (!m_hDlg) {
		return false;
	}

	EnableWindow(m_hWndParent, FALSE);
	ShowWindow(m_hDlg, SW_SHOW);

	DoEvents();

	return true;
}

//----------------------------------------------------------------------
// i\
//----------------------------------------------------------------------

void CProgressDlg::StepIt()
{
	++m_step;
	SetStep(m_step);
}

//----------------------------------------------------------------------
// I\
//----------------------------------------------------------------------

void CProgressDlg::TerminateStep(const char* progressMsg)
{
	DoEvents();

	// {^gȂ悤ɂ
	HWND hWndCancel = GetDlgItem(m_hDlg, IDCANCEL);
	EnableWindow(hWndCancel, FALSE);

	// ieLXgݒ肷
	HWND hProgressText = GetDlgItem(m_hDlg, IDC_PROGRESS_TEXT);
	SetWindowText(hProgressText, progressMsg);

	DoEvents();
}

//----------------------------------------------------------------------
// LZꂽ𓾂
//----------------------------------------------------------------------

bool CProgressDlg::IsCancel()
{
	DoEvents();

	if (m_bCancel) {
		return true;
	}

	if (!m_hDlg) {
		return true;
	}

	if (!IsWindow(m_hDlg)) {
		return true;
	}

	return false;
}

//----------------------------------------------------------------------
// I
//----------------------------------------------------------------------

void CProgressDlg::EndDialog()
{
	DoEvents();

	Destory();
}

//----------------------------------------------------------------------
// _CAOvV[W(]p)
//----------------------------------------------------------------------

BOOL CALLBACK CProgressDlg::DialogProcStatic(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// _CAOvV[W
//----------------------------------------------------------------------

BOOL CProgressDlg::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_CLOSE, OnClose);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CProgressDlg::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// _CAO𒆉ɕ\
	//
	HWND hWndParent = GetParent(hWnd);
	Util::CenterWindow(hWndParent, hWnd);

	//
	// s
	//

	// ^Cgݒ肷
	SetWindowText(hWnd, m_caption.c_str());

	// vOXo[͈̔͂
	HWND hProgessBar = GetDlgItem(hWnd, IDC_PROGRESS_BAR);
	SendMessage(hProgessBar, PBM_SETRANGE, 0, MAKELPARAM(0, 100));

	// ݒs
	SetStep(0);

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void CProgressDlg::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	switch (idCtl) {
	case IDCANCEL:
		Cancel();
		break;
	}
}

//----------------------------------------------------------------------
// WM_CLOSE nh
//----------------------------------------------------------------------

void CProgressDlg::OnClose(HWND hwnd)
{
	Cancel();
}

//----------------------------------------------------------------------
// i\
//----------------------------------------------------------------------

void CProgressDlg::SetStep(int step)
{
	DoEvents();

	// vOXo[ݒ肷
	int pos = 0;
	if (m_stepMax <= step) {
		pos = 100;
	} else if (0 < m_stepMax) {
		pos = (int) (step * 100.0 / m_stepMax);
	}

	HWND hProgessBar = GetDlgItem(m_hDlg, IDC_PROGRESS_BAR);
	SendMessage(hProgessBar, PBM_SETPOS, pos, 0);

	// ieLXgݒ肷
	std::string progressMsg = CResourceManager::FormatResourceString(IDS_MSG_PROGRESS_TEXT, step, m_stepMax);
	HWND hProgressText = GetDlgItem(m_hDlg, IDC_PROGRESS_TEXT);
	SetWindowText(hProgressText, progressMsg.c_str());

	DoEvents();
}

//----------------------------------------------------------------------
// LZ
//----------------------------------------------------------------------

void CProgressDlg::Cancel()
{
	m_bCancel = true;
}

//----------------------------------------------------------------------
// EBhEj
//----------------------------------------------------------------------

void CProgressDlg::Destory()
{
	if (m_hDlg) {
		ShowWindow(m_hDlg, SW_HIDE);
		DestroyWindow(m_hDlg);
		m_hDlg = 0;
	}
	if (m_hWndParent) {
		EnableWindow(m_hWndParent, TRUE);
		m_hWndParent = 0;
	}
}

//----------------------------------------------------------------------
// Cxg[v
//----------------------------------------------------------------------

void CProgressDlg::DoEvents()
{
	MSG msg;

	while (PeekMessage(&msg, 0, 0, 0, PM_REMOVE)) {
		if (msg.message == WM_QUIT) {
			break;
		}
		if (!m_hDlg || !IsDialogMessage(m_hDlg, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
}
